blob: 226730a9b20c39c11267a1b9d6784fb62266ba02 [file] [log] [blame]
Benedikt Böhm00ccea62010-01-26 12:39:36 +01001#
Vincent Driessen6c2d30b2010-01-26 22:18:36 +01002# git-flow -- A collection of Git extensions to provide high-level
3# repository operations for Vincent Driessen's branching model.
Benedikt Böhm00ccea62010-01-26 12:39:36 +01004#
5# Original blog post presenting this model is found at:
Vincent Driessenddb350b2010-07-09 09:42:09 +02006# http://nvie.com/git-model
Benedikt Böhm00ccea62010-01-26 12:39:36 +01007#
8# Feel free to contribute to this project at:
9# http://github.com/nvie/gitflow
10#
Vincent Driessend72acba2010-04-04 16:10:17 +020011# Copyright 2010 Vincent Driessen. All rights reserved.
12#
13# Redistribution and use in source and binary forms, with or without
14# modification, are permitted provided that the following conditions are met:
15#
16# 1. Redistributions of source code must retain the above copyright notice,
17# this list of conditions and the following disclaimer.
18#
19# 2. Redistributions in binary form must reproduce the above copyright
20# notice, this list of conditions and the following disclaimer in the
21# documentation and/or other materials provided with the distribution.
22#
23# THIS SOFTWARE IS PROVIDED BY VINCENT DRIESSEN ``AS IS'' AND ANY EXPRESS OR
24# IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
25# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
26# EVENT SHALL VINCENT DRIESSEN OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
27# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
28# BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
29# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY
30# OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
31# NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE,
32# EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
33#
34# The views and conclusions contained in the software and documentation are
35# those of the authors and should not be interpreted as representing official
36# policies, either expressed or implied, of Vincent Driessen.
Benedikt Böhm00ccea62010-01-26 12:39:36 +010037#
38
Vincent Driessen7832d6e2010-02-21 21:31:03 +010039require_git_repo
40require_gitflow_initialized
Vincent Driessend72e4ac2010-02-16 21:33:51 +010041gitflow_load_settings
Vincent Driessenc1598bf2010-02-20 16:52:48 +010042PREFIX=$(git config --get gitflow.prefix.feature)
Benedikt Böhm49dd62b2010-01-28 00:51:15 +010043
Benedikt Böhm00ccea62010-01-26 12:39:36 +010044usage() {
Vincent Driessenb03cf962010-02-01 22:00:39 +010045 echo "usage: git flow feature [list] [-v]"
Vincent Driessen2b829ce2010-07-09 09:36:20 +020046 echo " git flow feature start [-F] <name> [<base>]"
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +020047 echo " git flow feature finish [-rFk] <name|nameprefix>"
Vincent Driessen186d2b52010-01-27 23:48:39 +010048 echo " git flow feature publish <name>"
49 echo " git flow feature track <name>"
Vincent Driessena2e41162010-02-24 01:37:07 +010050 echo " git flow feature diff [<name|nameprefix>]"
51 echo " git flow feature rebase [-i] [<name|nameprefix>]"
Vincent Driessend43ab842010-05-27 11:26:01 -070052 echo " git flow feature checkout [<name|nameprefix>]"
Vincent Driessenf68d4052010-07-09 12:34:18 +020053 echo " git flow feature pull <remote> [<name>]"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010054}
55
Vincent Driessen186d2b52010-01-27 23:48:39 +010056cmd_default() {
Vincent Driessenb866b012010-01-28 01:01:53 +010057 cmd_list "$@"
Benedikt Böhm00ccea62010-01-26 12:39:36 +010058}
59
Vincent Driessenb866b012010-01-28 01:01:53 +010060cmd_list() {
Vincent Driessen44174922010-02-02 23:53:21 +010061 DEFINE_boolean verbose false 'verbose (more) output' v
Vincent Driessen1b819232010-02-01 15:51:43 +010062 parse_args "$@"
63
Vincent Driessenf46e2902010-02-15 23:01:52 +010064 local feature_branches
65 local current_branch
66 local short_names
Vincent Driessen7832d6e2010-02-21 21:31:03 +010067 feature_branches=$(echo "$(git_local_branches)" | grep "^$PREFIX")
Vincent Driessen27592dd2010-02-06 14:45:39 +010068 if [ -z "$feature_branches" ]; then
Vincent Driessen186d2b52010-01-27 23:48:39 +010069 warn "No feature branches exist."
Randy Merrillb681b452010-06-26 13:14:15 +080070 warn ""
71 warn "You can start a new feature branch:"
72 warn ""
73 warn " git flow feature start <name> [<base>]"
Randy Merrill4de01f22010-06-26 13:19:06 +080074 warn ""
Vincent Driessen186d2b52010-01-27 23:48:39 +010075 exit 0
76 fi
Adam Gibbinscf3da5a2010-08-22 19:13:34 +010077 current_branch=$(git branch --no-color | grep '^\* ' | grep -v 'no branch' | sed 's/^* //g')
Vincent Driessen27592dd2010-02-06 14:45:39 +010078 short_names=$(echo "$feature_branches" | sed "s ^$PREFIX g")
Vincent Driessenf2536f42010-02-01 15:57:48 +010079
Vincent Driessenaa6d0162010-02-01 19:43:46 +010080 # determine column width first
Vincent Driessenf46e2902010-02-15 23:01:52 +010081 local width=0
82 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010083 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010084 local len=${#branch}
Vincent Driessenaa6d0162010-02-01 19:43:46 +010085 width=$(max $width $len)
86 done
Vincent Driessenf46e2902010-02-15 23:01:52 +010087 width=$(($width+3))
Vincent Driessen1adbc3e2010-01-30 16:28:20 +010088
Vincent Driessenf46e2902010-02-15 23:01:52 +010089 local branch
Vincent Driessen27592dd2010-02-06 14:45:39 +010090 for branch in $short_names; do
Vincent Driessenf46e2902010-02-15 23:01:52 +010091 local fullname=$PREFIX$branch
92 local base=$(git merge-base "$fullname" "$DEVELOP_BRANCH")
93 local develop_sha=$(git rev-parse "$DEVELOP_BRANCH")
94 local branch_sha=$(git rev-parse "$fullname")
Vincent Driessen27592dd2010-02-06 14:45:39 +010095 if [ "$fullname" = "$current_branch" ]; then
Vincent Driessenaa6d0162010-02-01 19:43:46 +010096 printf "* "
97 else
98 printf " "
99 fi
Vincent Driessen44174922010-02-02 23:53:21 +0100100 if flag verbose; then
Vincent Driessen1adbc3e2010-01-30 16:28:20 +0100101 printf "%-${width}s" "$branch"
Vincent Driessenf2536f42010-02-01 15:57:48 +0100102 if [ "$branch_sha" = "$develop_sha" ]; then
103 printf "(no commits yet)"
104 elif [ "$base" = "$branch_sha" ]; then
105 printf "(is behind develop, may ff)"
106 elif [ "$base" = "$develop_sha" ]; then
107 printf "(based on latest develop)"
108 else
109 printf "(may be rebased)"
110 fi
Vincent Driessenaa6d0162010-02-01 19:43:46 +0100111 else
112 printf "%s" "$branch"
113 fi
114 echo
115 done
Vincent Driessen186d2b52010-01-27 23:48:39 +0100116}
117
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100118cmd_help() {
119 usage
120 exit 0
121}
122
Vincent Driessend0991262010-02-06 21:19:07 +0100123require_name_arg() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100124 if [ "$NAME" = "" ]; then
Vincent Driessen3c337fb2010-02-04 11:30:18 +0100125 warn "Missing argument <name>"
Vincent Driessen1b819232010-02-01 15:51:43 +0100126 usage
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100127 exit 1
128 fi
129}
130
Vincent Driessend0991262010-02-06 21:19:07 +0100131expand_nameprefix_arg() {
132 require_name_arg
133
Vincent Driessenf46e2902010-02-15 23:01:52 +0100134 local expanded_name
135 local exitcode
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100136 expanded_name=$(gitflow_resolve_nameprefix "$NAME" "$PREFIX")
Vincent Driessend0991262010-02-06 21:19:07 +0100137 exitcode=$?
138 case $exitcode in
139 0) NAME=$expanded_name
140 BRANCH=$PREFIX$NAME
141 ;;
142 *) exit 1 ;;
143 esac
Vincent Driessen2e1856b2010-01-29 15:18:13 +0100144}
145
Vincent Driessenf68d4052010-07-09 12:34:18 +0200146use_current_feature_branch_name() {
147 local current_branch=$(git_current_branch)
148 if startswith "$current_branch" "$PREFIX"; then
149 BRANCH=$current_branch
150 NAME=${BRANCH#$PREFIX}
151 else
152 warn "The current HEAD is no feature branch."
153 warn "Please specify a <name> argument."
154 exit 1
155 fi
156}
157
Vincent Driessend0991262010-02-06 21:19:07 +0100158expand_nameprefix_arg_or_current() {
Vincent Driessenc62633f2010-02-02 10:48:50 +0100159 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100160 expand_nameprefix_arg
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100161 require_branch "$PREFIX$NAME"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100162 else
Vincent Driessenf68d4052010-07-09 12:34:18 +0200163 use_current_feature_branch_name
Vincent Driessenc62633f2010-02-02 10:48:50 +0100164 fi
165}
166
Vincent Driessenf68d4052010-07-09 12:34:18 +0200167name_or_current() {
168 if [ -z "$NAME" ]; then
169 use_current_feature_branch_name
170 fi
171}
172
Vincent Driessen68e53aa2011-02-03 16:29:50 +0100173parse_args() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100174 # parse options
175 FLAGS "$@" || exit $?
176 eval set -- "${FLAGS_ARGV}"
177
178 # read arguments into global variables
Vincent Driessenf1eaa4e2011-02-03 16:11:25 +0100179 NAME=$1
Vincent Driessen11560922010-02-01 21:58:37 +0100180 BRANCH=$PREFIX$NAME
Vincent Driessenb866b012010-01-28 01:01:53 +0100181}
182
Vincent Driessenf68d4052010-07-09 12:34:18 +0200183parse_remote_name() {
Vincent Driessen68e53aa2011-02-03 16:29:50 +0100184 # parse options
185 FLAGS "$@" || exit $?
186 eval set -- "${FLAGS_ARGV}"
Vincent Driessenf68d4052010-07-09 12:34:18 +0200187
188 # read arguments into global variables
189 REMOTE=$1
190 NAME=$2
191 BRANCH=$PREFIX$NAME
192}
193
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100194cmd_start() {
Vincent Driessen44174922010-02-02 23:53:21 +0100195 DEFINE_boolean fetch false 'fetch from origin before performing local operation' F
Vincent Driessenea608952010-01-29 16:56:29 +0100196 parse_args "$@"
Vincent Driessenc5fcc012010-02-10 00:18:08 +0100197 BASE=${2:-$DEVELOP_BRANCH}
Vincent Driessend0991262010-02-06 21:19:07 +0100198 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100199
200 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100201 require_branch_absent "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100202
203 # update the local repo with remote changes, if asked
Vincent Driessen44174922010-02-02 23:53:21 +0100204 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100205 git fetch -q "$ORIGIN" "$DEVELOP_BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100206 fi
207
Vincent Driessenc118a852010-04-04 16:32:04 +0200208 # if the origin branch counterpart exists, assert that the local branch
209 # isn't behind it (to avoid unnecessary rebasing)
210 if git_branch_exists "$ORIGIN/$DEVELOP_BRANCH"; then
211 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
212 fi
Vincent Driessene034e4a2010-01-29 12:10:44 +0100213
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100214 # create branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100215 if ! git checkout -b "$BRANCH" "$BASE"; then
Vincent Driessen5455a6f2010-02-03 00:14:05 +0100216 die "Could not create feature branch '$BRANCH'"
217 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100218
219 echo
220 echo "Summary of actions:"
221 echo "- A new branch '$BRANCH' was created, based on '$BASE'"
222 echo "- You are now on branch '$BRANCH'"
223 echo ""
224 echo "Now, start committing on your feature. When done, use:"
225 echo ""
gmallard192ff522010-04-01 19:31:09 -0400226 echo " git flow feature finish $NAME"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100227 echo
228}
229
230cmd_finish() {
Vincent Driessenca73caf2010-02-07 19:46:38 +0100231 DEFINE_boolean fetch false "fetch from $ORIGIN before performing finish" F
Vincent Driessenddd9dfe2010-10-05 12:34:38 +0200232 DEFINE_boolean rebase false "rebase instead of merge" r
233 DEFINE_boolean keep false "keep branch after performing finish" k
Vincent Driessen1b819232010-02-01 15:51:43 +0100234 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100235 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100236
237 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100238 require_branch "$BRANCH"
Vincent Driessene034e4a2010-01-29 12:10:44 +0100239
Vincent Driessen49c7d022010-01-28 12:40:33 +0100240 # detect if we're restoring from a merge conflict
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100241 if [ -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE" ]; then
Vincent Driessen49c7d022010-01-28 12:40:33 +0100242 #
243 # TODO: detect that we're working on the correct branch here!
244 # The user need not necessarily have given the same $NAME twice here
245 # (although he/she should).
246 #
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100247
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100248 # TODO: git_is_clean_working_tree() should provide an alternative
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100249 # exit code for "unmerged changes in working tree", which we should
250 # actually be testing for here
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100251 if git_is_clean_working_tree; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100252 FINISH_BASE=$(cat "$DOT_GIT_DIR/.gitflow/MERGE_BASE")
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100253
254 # Since the working tree is now clean, either the user did a
255 # succesfull merge manually, or the merge was cancelled.
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100256 # We detect this using git_is_branch_merged_into()
257 if git_is_branch_merged_into "$BRANCH" "$FINISH_BASE"; then
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100258 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100259 helper_finish_cleanup
260 exit 0
261 else
262 # If the user cancelled the merge and decided to wait until later,
263 # that's fine. But we have to acknowledge this by removing the
264 # MERGE_BASE file and continuing normal execution of the finish
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100265 rm -f "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100266 fi
Vincent Driessen49c7d022010-01-28 12:40:33 +0100267 else
268 echo
269 echo "Merge conflicts not resolved yet, use:"
270 echo " git mergetool"
271 echo " git commit"
272 echo
273 echo "You can then complete the finish by running it again:"
274 echo " git flow feature finish $NAME"
275 echo
276 exit 1
277 fi
278 fi
279
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100280 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100281 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100282
Vincent Driessene034e4a2010-01-29 12:10:44 +0100283 # update local repo with remote changes first, if asked
Mark Derricutt8a86c482010-07-20 21:11:48 +1200284 if has "$ORIGIN/$BRANCH" "$(git_remote_branches)"; then
Vincent Driessencb654b12010-07-21 13:28:54 +0200285 if flag fetch; then
286 git fetch -q "$ORIGIN" "$BRANCH"
287 fi
Vincent Driessene034e4a2010-01-29 12:10:44 +0100288 fi
289
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100290 if has "$ORIGIN/$BRANCH" "$(git_remote_branches)"; then
291 require_branches_equal "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100292 fi
Mark Derricutt8a86c482010-07-20 21:11:48 +1200293 if has "$ORIGIN/$DEVELOP_BRANCH" "$(git_remote_branches)"; then
Vincent Driessencb654b12010-07-21 13:28:54 +0200294 require_branches_equal "$DEVELOP_BRANCH" "$ORIGIN/$DEVELOP_BRANCH"
295 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100296
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100297 # if the user wants to rebase, do that first
Vincent Driessen44174922010-02-02 23:53:21 +0100298 if flag rebase; then
Vincent Driessen010252a2010-02-04 10:31:29 +0100299 if ! git flow feature rebase "$NAME" "$DEVELOP_BRANCH"; then
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100300 warn "Finish was aborted due to conflicts during rebase."
301 warn "Please finish the rebase manually now."
302 warn "When finished, re-run:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100303 warn " git flow feature finish '$NAME' '$DEVELOP_BRANCH'"
Vincent Driessen95bf82c2010-02-02 11:58:37 +0100304 exit 1
305 fi
306 fi
307
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100308 # merge into BASE
Vincent Driessena4dd2232010-02-10 00:34:59 +0100309 git checkout "$DEVELOP_BRANCH"
310 if [ "$(git rev-list -n2 "$DEVELOP_BRANCH..$BRANCH" | wc -l)" -eq 1 ]; then
311 git merge --ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100312 else
Vincent Driessena4dd2232010-02-10 00:34:59 +0100313 git merge --no-ff "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100314 fi
315
Vincent Driessen49c7d022010-01-28 12:40:33 +0100316 if [ $? -ne 0 ]; then
317 # oops.. we have a merge conflict!
Vincent Driessen010252a2010-02-04 10:31:29 +0100318 # write the given $DEVELOP_BRANCH to a temporary file (we need it later)
Vincent Driessencf6e92a2010-02-19 19:44:48 +0100319 mkdir -p "$DOT_GIT_DIR/.gitflow"
320 echo "$DEVELOP_BRANCH" > "$DOT_GIT_DIR/.gitflow/MERGE_BASE"
Vincent Driessen49c7d022010-01-28 12:40:33 +0100321 echo
322 echo "There were merge conflicts. To resolve the merge conflict manually, use:"
323 echo " git mergetool"
324 echo " git commit"
325 echo
326 echo "You can then complete the finish by running it again:"
327 echo " git flow feature finish $NAME"
328 echo
329 exit 1
330 fi
331
332 # when no merge conflict is detected, just clean up the feature branch
333 helper_finish_cleanup
334}
335
336helper_finish_cleanup() {
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100337 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100338 require_branch "$BRANCH"
339 require_clean_working_tree
Vincent Driessenf6f152f2010-01-29 10:28:08 +0100340
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100341 # delete branch
Vincent Driessen44174922010-02-02 23:53:21 +0100342 if flag fetch; then
Vincent Driessena4dd2232010-02-10 00:34:59 +0100343 git push "$ORIGIN" ":refs/heads/$BRANCH"
Vincent Driesseneec73c62010-02-02 16:14:16 +0100344 fi
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200345
346
Vincent Driessenddd9dfe2010-10-05 12:34:38 +0200347 if noflag keep; then
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200348 git branch -d "$BRANCH"
349 fi
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100350
351 echo
352 echo "Summary of actions:"
Vincent Driessen010252a2010-02-04 10:31:29 +0100353 echo "- The feature branch '$BRANCH' was merged into '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100354 #echo "- Merge conflicts were resolved" # TODO: Add this line when it's supported
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200355 if flag keep; then
Vincent Driessenddd9dfe2010-10-05 12:34:38 +0200356 echo "- Feature branch '$BRANCH' is still available"
Guillaume-Jean Herbiet8fee0c22010-10-04 11:35:10 +0200357 else
358 echo "- Feature branch '$BRANCH' has been removed"
359 fi
Vincent Driessen010252a2010-02-04 10:31:29 +0100360 echo "- You are now on branch '$DEVELOP_BRANCH'"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100361 echo
362}
363
364cmd_publish() {
Vincent Driessenea608952010-01-29 16:56:29 +0100365 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100366 expand_nameprefix_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100367
368 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100369 require_clean_working_tree
370 require_branch "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100371 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100372 require_branch_absent "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100373
374 # create remote branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100375 git push "$ORIGIN" "$BRANCH:refs/heads/$BRANCH"
376 git fetch -q "$ORIGIN"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100377
378 # configure remote tracking
Vincent Driessena4dd2232010-02-10 00:34:59 +0100379 git config "branch.$BRANCH.remote" "$ORIGIN"
380 git config "branch.$BRANCH.merge" "refs/heads/$BRANCH"
381 git checkout "$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100382
383 echo
384 echo "Summary of actions:"
385 echo "- A new remote branch '$BRANCH' was created"
386 echo "- The local branch '$BRANCH' was configured to track the remote branch"
387 echo "- You are now on branch '$BRANCH'"
388 echo
389}
390
391cmd_track() {
Vincent Driessenea608952010-01-29 16:56:29 +0100392 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100393 require_name_arg
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100394
395 # sanity checks
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100396 require_clean_working_tree
397 require_branch_absent "$BRANCH"
Vincent Driessena4dd2232010-02-10 00:34:59 +0100398 git fetch -q "$ORIGIN"
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100399 require_branch "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100400
401 # create tracking branch
Vincent Driessena4dd2232010-02-10 00:34:59 +0100402 git checkout -b "$BRANCH" "$ORIGIN/$BRANCH"
Benedikt Böhm00ccea62010-01-26 12:39:36 +0100403
404 echo
405 echo "Summary of actions:"
406 echo "- A new remote tracking branch '$BRANCH' was created"
407 echo "- You are now on branch '$BRANCH'"
408 echo
409}
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100410
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100411cmd_diff() {
Vincent Driessen1b819232010-02-01 15:51:43 +0100412 parse_args "$@"
Vincent Driessen1b819232010-02-01 15:51:43 +0100413
Vincent Driessen5474e462010-02-04 15:50:06 +0100414 if [ "$NAME" != "" ]; then
Vincent Driessend0991262010-02-06 21:19:07 +0100415 expand_nameprefix_arg
Vincent Driessena4dd2232010-02-10 00:34:59 +0100416 BASE=$(git merge-base "$DEVELOP_BRANCH" "$BRANCH")
417 git diff "$BASE..$BRANCH"
Vincent Driessen5474e462010-02-04 15:50:06 +0100418 else
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100419 if ! git_current_branch | grep -q "^$PREFIX"; then
Vincent Driessen5474e462010-02-04 15:50:06 +0100420 die "Not on a feature branch. Name one explicitly."
421 fi
422
Vincent Driessena4dd2232010-02-10 00:34:59 +0100423 BASE=$(git merge-base "$DEVELOP_BRANCH" HEAD)
424 git diff "$BASE"
Vincent Driessen5474e462010-02-04 15:50:06 +0100425 fi
Vincent Driessenbd4f0952010-01-27 13:57:15 +0100426}
Vincent Driessenc62633f2010-02-02 10:48:50 +0100427
Vincent Driessend43ab842010-05-27 11:26:01 -0700428cmd_checkout() {
429 parse_args "$@"
430
431 if [ "$NAME" != "" ]; then
432 expand_nameprefix_arg
433 git checkout "$BRANCH"
434 else
435 die "Name a feature branch explicitly."
436 fi
437}
438
Vincent Driessena2baef92010-05-27 11:52:31 -0700439cmd_co() {
440 # Alias for checkout
441 cmd_checkout "$@"
442}
443
Vincent Driessenc62633f2010-02-02 10:48:50 +0100444cmd_rebase() {
Vincent Driessen44174922010-02-02 23:53:21 +0100445 DEFINE_boolean interactive false 'do an interactive rebase' i
Vincent Driessenc62633f2010-02-02 10:48:50 +0100446 parse_args "$@"
Vincent Driessend0991262010-02-06 21:19:07 +0100447 expand_nameprefix_arg_or_current
Vincent Driessenc62633f2010-02-02 10:48:50 +0100448 warn "Will try to rebase '$NAME'..."
Vincent Driessen7832d6e2010-02-21 21:31:03 +0100449 require_clean_working_tree
450 require_branch "$BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100451
452 git checkout -q "$BRANCH"
Vincent Driessenf46e2902010-02-15 23:01:52 +0100453 local OPTS=
Vincent Driessen44174922010-02-02 23:53:21 +0100454 if flag interactive; then
Vincent Driessenc62633f2010-02-02 10:48:50 +0100455 OPTS="$OPTS -i"
456 fi
Vincent Driessen010252a2010-02-04 10:31:29 +0100457 git rebase $OPTS "$DEVELOP_BRANCH"
Vincent Driessenc62633f2010-02-02 10:48:50 +0100458}
Vincent Driessenf68d4052010-07-09 12:34:18 +0200459
460avoid_accidental_cross_branch_action() {
461 local current_branch=$(git_current_branch)
462 if [ "$BRANCH" != "$current_branch" ]; then
463 warn "Trying to pull from '$BRANCH' while currently on branch '$current_branch'."
464 warn "To avoid unintended merges, git-flow aborted."
465 return 1
466 fi
467 return 0
468}
469
470cmd_pull() {
471 #DEFINE_string prefix false 'alternative remote feature branch name prefix' p
472 parse_remote_name "$@"
473
474 if [ -z "$REMOTE" ]; then
475 die "Name a remote explicitly."
476 fi
477 name_or_current
478
479 # To avoid accidentally merging different feature branches into each other,
480 # die if the current feature branch differs from the requested $NAME
481 # argument.
482 local current_branch=$(git_current_branch)
483 if startswith "$current_branch" "$PREFIX"; then
484 # we are on a local feature branch already, so $BRANCH must be equal to
485 # the current branch
486 avoid_accidental_cross_branch_action || die
487 fi
488
489 require_clean_working_tree
490
491 if git_branch_exists "$BRANCH"; then
492 # Again, avoid accidental merges
493 avoid_accidental_cross_branch_action || die
494
495 # we already have a local branch called like this, so simply pull the
496 # remote changes in
497 git pull -q "$REMOTE" "$BRANCH" || die "Failed to pull from remote '$REMOTE'."
498 echo "Pulled $REMOTE's changes into $BRANCH."
499 else
500 # setup the local branch clone for the first time
501 git fetch -q "$REMOTE" "$BRANCH" || die "Fetch failed." # stores in FETCH_HEAD
502 git branch --no-track "$BRANCH" FETCH_HEAD || die "Branch failed."
503 git checkout -q "$BRANCH" || die "Checking out new local branch failed."
504 echo "Created local branch $BRANCH based on $REMOTE's $BRANCH."
505 fi
506}